diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/daemon/common/commonInteractive.ml ./src/daemon/common/commonInteractive.ml
--- ./src/daemon/common/commonInteractive.ml	2006-01-11 20:12:34.000000000 +0100
+++ ./src/daemon/common/commonInteractive.ml	2006-02-16 14:02:05.000000000 +0100
@@ -185,7 +185,6 @@
               Unix2.chmod new_name (Misc.int_of_octal_string !!create_dir_mask);
             let best_name = file_best_name file in
             Unix32.destroy (file_fd file);
-            if !verbose then lprintf_nl () " file_commit: destroyed";
             if Unix2.is_directory file_name then Unix2.remove_all_directory file_name;
             let impl = as_file_impl file in
 
@@ -208,7 +207,6 @@
             done_files =:= List2.removeq file !!done_files;
             files =:= List2.removeq file !!files;
 
-            if !verbose then lprintf_nl () "file_commit: going to secondaries...";
             List.iter (fun file ->
 (* Commit the file first, and share it after... *)
                 try
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/daemon/common/commonRoom.ml ./src/daemon/common/commonRoom.ml
--- ./src/daemon/common/commonRoom.ml	2005-10-10 18:22:24.000000000 +0200
+++ ./src/daemon/common/commonRoom.ml	2006-02-16 15:34:16.000000000 +0100
@@ -236,7 +236,7 @@
         op_room_close = (fun room -> 
             set_room_state (as_room room.room_impl) RoomOpened);  
         op_room_messages = (fun _ -> fni network "room_messages");
-        op_room_users = (fun _ -> fni network "room_users");
+        op_room_users = (fun _ -> failwith "not implemented");
         op_room_name = (fun _ -> fni network "room_name");
         op_room_info = (let module P = GuiTypes in
           fun r -> 
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/donkey/donkeyClient.ml ./src/networks/donkey/donkeyClient.ml
--- ./src/networks/donkey/donkeyClient.ml	2006-02-11 15:52:45.000000000 +0100
+++ ./src/networks/donkey/donkeyClient.ml	2006-02-16 14:21:48.000000000 +0100
@@ -647,7 +647,7 @@
     | 6 -> Brand_hydranode
     | 10 -> Brand_mldonkey3
     | 20 -> Brand_lphant
-    | _ -> lprintf_nl () "unknown compatibleclient %d (please report to dev team)" num; Brand_unknown
+    | _ -> Brand_unknown
 
 let parse_mod_version s c =
   let rec iter i len =
@@ -700,7 +700,7 @@
           for_int_tag tag (fun i ->
             c.client_brand <- parse_compatible_client i c.client_brand;
             if c.client_brand = Brand_unknown then
-              lprintf_nl () "[compatibleclient] Brand_unknown %s" (full_client_identifier c);
+              lprintf_nl () "unknown compatibleclient %d (%s) (please report to dev team)" i (full_client_identifier c)
           )
       | Field_UNKNOWN "compression" ->
           for_int_tag tag (fun i ->
@@ -2609,27 +2609,30 @@
   DonkeySources.functions.DonkeySources.function_add_location <- (fun
       s_uid file_uid ->
       try
-        let c = new_client s_uid in
         let file = find_file (Md4.of_string file_uid) in
+        let c = new_client s_uid in
         
         CommonFile.file_add_source (CommonFile.as_file file.file_file) 
         (CommonClient.as_client c.client_client);
       
-      with e -> 
-        if !verbose then begin
-          lprintf_nl () "add_location: exception %s" (Printexc2.to_string e);
-        end
+      with
+	Not_found -> ()
+      | e -> 
+        if !verbose then
+          lprintf_nl () "add_location: exception %s" (Printexc2.to_string e)
   );
   
   DonkeySources.functions.DonkeySources.function_remove_location <- (fun
       s_uid file_uid ->
       try
-        let c = new_client s_uid in
         let file = find_file (Md4.of_string file_uid) in
+        let c = new_client s_uid in
         CommonFile.file_remove_source (CommonFile.as_file file.file_file)
         (CommonClient.as_client c.client_client);
         
-      with e -> 
+      with
+	Not_found -> ()
+      | e -> 
         if !verbose then
           lprintf_nl () "remove_location for file_md4 %s: exception %s"
       file_uid (Printexc2.to_string e)
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/donkey/donkeyComplexOptions.ml ./src/networks/donkey/donkeyComplexOptions.ml
--- ./src/networks/donkey/donkeyComplexOptions.ml	2006-01-11 19:53:30.000000000 +0100
+++ ./src/networks/donkey/donkeyComplexOptions.ml	2006-02-16 14:29:54.000000000 +0100
@@ -706,12 +706,12 @@
 let check_result r tags =
   if r.result_names = [] || r.result_size = Int64.zero then begin
       if !verbose then begin
-          lprintf_n () "BAD RESULT:";
+          lprintf_n () "Bad search result: ";
           List.iter (fun tag ->
-              lprintf "[%s] = [%s]" (string_of_field tag.tag_name)
-                (string_of_tag_value tag.tag_value);
-              lprint_newline ();
+              lprintf "[%s] = [%s] " (string_of_field tag.tag_name)
+                (string_of_tag_value tag.tag_value)
           ) tags;
+	  lprint_newline ();
         end;
       false
     end
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/donkey/donkeyOneFile.ml ./src/networks/donkey/donkeyOneFile.ml
--- ./src/networks/donkey/donkeyOneFile.ml	2005-12-18 15:50:38.000000000 +0100
+++ ./src/networks/donkey/donkeyOneFile.ml	2006-02-16 15:02:40.000000000 +0100
@@ -136,8 +136,6 @@
   file_completed (as_file file);
   Int64Swarmer.remove_swarmer file.file_swarmer;
   file.file_swarmer <- None;
-  
-  
   unshare_file file;
   ignore (CommonShared.new_shared "completed" 0 (
       file_best_name file )
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/donkey/donkeyShare.ml ./src/networks/donkey/donkeyShare.ml
--- ./src/networks/donkey/donkeyShare.ml	2006-02-06 22:45:04.000000000 +0100
+++ ./src/networks/donkey/donkeyShare.ml	2006-02-16 16:43:06.000000000 +0100
@@ -197,6 +197,8 @@
 files being shared !
 *)
 
+exception Wrong_file_size
+
 let computation = ref false
 
 (*   Compute (at most) one MD4 chunk if needed. *)
@@ -208,14 +210,10 @@
     | sh :: files ->
         let rec job_creater _ =
           try
-            if not (Sys.file_exists sh.shared_name) then begin
-                lprintf_nl () "Shared file doesn't exist";
-                raise Not_found;
-              end;
-            if Unix32.getsize sh.shared_name <> sh.shared_size then begin
-                lprintf_nl () "Bad shared file size";
+            if not (Sys.file_exists sh.shared_name) then
                 raise Not_found;
-              end;
+            if Unix32.getsize sh.shared_name <> sh.shared_size then
+                raise Wrong_file_size;
             computation := true;
             let end_pos = sh.shared_pos ++ block_size in
             let end_pos = if end_pos > sh.shared_size then sh.shared_size
@@ -252,8 +250,9 @@
                 else
                   job_creater ())
           with e ->
-              lprintf_nl () "Exception %s prevents sharing"
-                (Printexc2.to_string e);
+	      shared_files := files;
+              lprintf_nl () "Exception %s prevents sharing of %s"
+                (Printexc2.to_string e) sh.shared_name
         in
         job_creater ()
 
@@ -286,9 +285,7 @@
 
 	  let found = ref false in
 	  List.iter (fun sh -> if sh.shared_name = fullname then found := true) !shared_files;
-	  if !found then
-	    lprintf_nl () "avoid sharing %s" fullname
-	  else begin
+	  if not !found then begin
           let rec impl = {
               impl_shared_update = 1;
               impl_shared_fullname = fullname;
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/utils/net/http_server.ml ./src/utils/net/http_server.ml
--- ./src/utils/net/http_server.ml	2005-12-05 19:37:34.000000000 +0100
+++ ./src/utils/net/http_server.ml	2006-02-16 14:52:59.000000000 +0100
@@ -97,9 +97,6 @@
 | Authorization of auth
 
 
-exception ProcessForked
-exception ThreadForked
-
 type options = {
     referer : Url.url option;
     content_length : int;
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/utils/net/http_server.mli ./src/utils/net/http_server.mli
--- ./src/utils/net/http_server.mli	2005-07-18 01:15:04.000000000 +0200
+++ ./src/utils/net/http_server.mli	2006-02-16 14:52:55.000000000 +0100
@@ -21,8 +21,6 @@
     Unknown of string * string
   | Referer of Url.url
   | Authorization of auth
-exception ProcessForked
-exception ThreadForked
 type options = {
     referer : Url.url option;
     content_length : int;
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/utils/net/tcpBufferedSocket.ml ./src/utils/net/tcpBufferedSocket.ml
--- ./src/utils/net/tcpBufferedSocket.ml	2006-01-14 23:16:45.000000000 +0100
+++ ./src/utils/net/tcpBufferedSocket.ml	2006-02-16 14:54:43.000000000 +0100
@@ -1021,7 +1021,6 @@
 (*      lprintf "close_after_write: CLOSE\n";  - log output removed  *)
         shutdown t Closed_by_user)
 
-exception Http_proxy_error of string
 let http_proxy = ref None
 
 let set_reader t f =