Index: Misc/XPlane.fed
===================================================================
RCS file: /sources/certi/applications/XPlaneHLAPlugin/Misc/XPlane.fed,v
retrieving revision 1.1
diff -u -r1.1 XPlane.fed
--- Misc/XPlane.fed	27 May 2008 14:05:49 -0000	1.1
+++ Misc/XPlane.fed	3 Nov 2008 11:29:56 -0000
@@ -8,18 +8,20 @@
        (attribute privilegeToDelete  reliable timestamp)
        (class RTIprivate)
 
-  (class Aircraft
+;; Compliant to the AviationSimNet FOM 3.1
+;; See http://www.aviationsimnet.org/ASN/downloads.html
+  (class aircraft
 
-     (attribute Aircraft_Type reliable timestamp)  ;; type aeronef
+     (attribute aircraftType reliable timestamp)  ;; type aeronef
 
 ;; Federate : local X,Y,Z,phi,theta,psi
 
-     (attribute Att_Lat reliable timestamp)
-     (attribute Att_Lon reliable timestamp)
-     (attribute Att_Hte reliable timestamp)
-     (attribute Att_Phi reliable timestamp)
-     (attribute Att_The reliable timestamp)
-	  (attribute Att_Psi reliable timestamp)
+     (attribute latitude reliable timestamp)
+     (attribute longitude reliable timestamp)
+     (attribute altitudeMSL reliable timestamp)
+     (attribute roll reliable timestamp)
+     (attribute pitch reliable timestamp)
+     (attribute trueHeading reliable timestamp)
  	  
   )
  )
Index: XPlane_PlugIn/XP_Run.cpp
===================================================================
RCS file: /sources/certi/applications/XPlaneHLAPlugin/XPlane_PlugIn/XP_Run.cpp,v
retrieving revision 1.2
diff -u -r1.2 XP_Run.cpp
--- XPlane_PlugIn/XP_Run.cpp	23 Jun 2008 14:35:41 -0000	1.2
+++ XPlane_PlugIn/XP_Run.cpp	3 Nov 2008 11:29:56 -0000
@@ -17,14 +17,14 @@
 {
 auto_ptr<RTI::AttributeHandleSet> attributes(RTI::AttributeHandleSetFactory::create(nbData));
 
-IDClass= getObjectClassHandle("Aircraft");
+IDClass= getObjectClassHandle("aircraft");
 
-ID_Att[leX]= getAttributeHandle("Att_Lat",IDClass); attributes->add(ID_Att[leX]);	//TODO : datas
-ID_Att[leY]= getAttributeHandle("Att_Lon",IDClass); attributes->add(ID_Att[leY]);
-ID_Att[leZ]= getAttributeHandle("Att_Hte",IDClass); attributes->add(ID_Att[leZ]);
-ID_Att[Phi]= getAttributeHandle("Att_Phi",IDClass); attributes->add(ID_Att[Phi]);
-ID_Att[The]= getAttributeHandle("Att_The",IDClass); attributes->add(ID_Att[The]);
-ID_Att[Psi]= getAttributeHandle("Att_Psi",IDClass); attributes->add(ID_Att[Psi]);
+ID_Att[leX]= getAttributeHandle("latitude",IDClass); attributes->add(ID_Att[leX]);	//TODO : datas
+ID_Att[leY]= getAttributeHandle("longitude",IDClass); attributes->add(ID_Att[leY]);
+ID_Att[leZ]= getAttributeHandle("altitudeMSL",IDClass); attributes->add(ID_Att[leZ]);
+ID_Att[Phi]= getAttributeHandle("roll",IDClass); attributes->add(ID_Att[Phi]);
+ID_Att[The]= getAttributeHandle("pitch",IDClass); attributes->add(ID_Att[The]);
+ID_Att[Psi]= getAttributeHandle("trueHeading",IDClass); attributes->add(ID_Att[Psi]);
 
 fprintf(fLog,"Publish attributes of class %d ",IDClass); fflush(fLog);
 publishObjectClass(IDClass, *attributes);
Index: XPlane_Trace/XP_Trace.cpp
===================================================================
RCS file: /sources/certi/applications/XPlaneHLAPlugin/XPlane_Trace/XP_Trace.cpp,v
retrieving revision 1.1
diff -u -r1.1 XP_Trace.cpp
--- XPlane_Trace/XP_Trace.cpp	27 May 2008 14:05:50 -0000	1.1
+++ XPlane_Trace/XP_Trace.cpp	3 Nov 2008 11:29:56 -0000
@@ -160,14 +160,14 @@
 {
 auto_ptr<RTI::AttributeHandleSet> attributes(RTI::AttributeHandleSetFactory::create(NBDATA));
 
-IDClass= getObjectClassHandle("Aircraft");
-ID_Att[leX]= getAttributeHandle("Att_Lat",IDClass); attributes->add(ID_Att[leX]);
-ID_Att[leY]= getAttributeHandle("Att_Lon",IDClass); attributes->add(ID_Att[leY]);
-ID_Att[leZ]= getAttributeHandle("Att_Hte",IDClass); attributes->add(ID_Att[leZ]);
-
-ID_Att[Phi]= getAttributeHandle("Att_Phi",IDClass); attributes->add(ID_Att[Phi]);
-ID_Att[The]= getAttributeHandle("Att_The",IDClass); attributes->add(ID_Att[The]);
-ID_Att[Psi]= getAttributeHandle("Att_Psi",IDClass); attributes->add(ID_Att[Psi]);
+IDClass= getObjectClassHandle("aircraft");
+ID_Att[leX]= getAttributeHandle("latitude",IDClass); attributes->add(ID_Att[leX]);
+ID_Att[leY]= getAttributeHandle("longitude",IDClass); attributes->add(ID_Att[leY]);
+ID_Att[leZ]= getAttributeHandle("altitudeMSL",IDClass); attributes->add(ID_Att[leZ]);
+
+ID_Att[Phi]= getAttributeHandle("roll",IDClass); attributes->add(ID_Att[Phi]);
+ID_Att[The]= getAttributeHandle("pitch",IDClass); attributes->add(ID_Att[The]);
+ID_Att[Psi]= getAttributeHandle("trueHeading",IDClass); attributes->add(ID_Att[Psi]);
 
 fprintf(fLog,"Subscribe attributes of class %d : %d,%d,%d <> %d,%d,%d",IDClass,ID_Att[leX],ID_Att[leY],ID_Att[leZ],
 																										 ID_Att[Phi],ID_Att[The],ID_Att[Psi]); fflush(fLog);